source: trunk/debathena/scripts/installer/install-debathena.beta.sh @ 25831

Revision 25831, 18.8 KB checked in by jdreed, 11 years ago (diff)
* Add values to the debconf preseeding, so that you can actually set the 'seen' flag * Ensure that the correct kernel headers are installed
Line 
1#!/bin/sh
2# Athena installer script.
3# Maintainer: debathena@mit.edu
4# Based on original Debathena installer script by: Tim Abbott <tabbott@mit.edu>
5
6# Download this to a Debian or Ubuntu machine and run it as root.  It can
7# be downloaded with:
8#   wget -N http://debathena.mit.edu/install-debathena.sh
9
10set -e
11
12# The user's umask will sometimes carry over; don't let that happen.
13umask 022
14
15output() {
16  printf '\033[38m'; echo "$@"; printf '\033[0m'
17}
18
19error() {
20  printf '\033[31m'; echo "$@"; printf '\033[0m'
21}
22
23ask() {
24  answer=''
25  while [ y != "$answer" -a n != "$answer" ]; do
26    printf '\033[38m'; echo -n "$1"; printf '\033[0m'
27    read answer
28    [ Y = "$answer" ] && answer=y
29    [ N = "$answer" ] && answer=n
30    [ -z "$answer" ] && answer=$2
31  done
32  output ""
33}
34
35if [ `id -u` != "0" ]; then
36  error "You must run the Debathena installer as root."
37  if [ -x /usr/bin/sudo ]; then
38    error "Try running 'sudo $0'."
39  fi
40  exit 1
41fi
42
43pxetype=
44if test -f /root/pxe-install-flag ; then
45  pxetype=`head -1 /root/pxe-install-flag`
46fi
47
48have_lsbrelease="$(dpkg-query -W -f '${Status}' lsb-release 2>/dev/null)"
49if [ "$have_lsbrelease" != "install ok installed" ]; then
50  echo "The installer requires the 'lsb-release' package to determine"
51  echo "whether or not installation can proceed."
52  ask "Is it ok to install this package now? [Y/n] " y
53  if [ y = "$answer" ]; then
54    if ! apt-get -qq update && apt-get -qqy install lsb-release; then
55        error "Could not install lsb-release.  Try installing it manually."
56        exit 1
57    fi
58  else
59    error "Sorry, lsb-release is required.  Cannot continue."
60    exit 1
61  fi
62fi
63distro=`lsb_release -cs`
64aptitude=aptitude
65case $distro in
66  squeeze)
67    ;;
68  hardy|lucid)
69    ubuntu=yes
70    ;;
71  oneiric|precise|quantal)
72    ubuntu=yes
73    aptitude=apt-get
74    ;;
75  raring)
76    ubuntu=yes
77    aptitude=apt-get
78    output "The release you are running ($distro) is not yet supported"
79    output "and installing Debathena on it is probably a bad idea,"
80    output "particularly for any purpose other than beta testing."
81    output ""
82    output "(New releases are generally supported a couple of weeks"
83    output "after the official release date.  We strongly encourage you"
84    output "to check http://debathena.mit.edu for support information"
85    output "and try again later, or install the previous version of"
86    output "the operating system.)"
87    if ! test -f /root/pxe-install-flag; then
88        ask "Are you sure you want to proceed? [y/N] " n
89        [ y != "$answer" ] && exit 1
90    fi
91    ;;
92  lenny|intrepid|jaunty|karmic|maverick|natty)
93    error "The release you are running ($distro) is no longer supported."
94    error "Generally, Debathena de-supports releases when they are no longer"
95    error "supported by upstream.  If you believe you received this message"
96    error "in error, please contact debathena@mit.edu."
97    exit 1
98    ;;
99  *)
100    error "Unsupported release codename: $distro"
101    error "Sorry, Debathena does not support installation on this release at this time."
102    error "(New releases may not be supported immediately after their release)."
103    error "If you believe you are running a supported release or have questions,"
104    error "please contact debathena@mit.edu"
105    exit 1
106    ;;
107esac
108
109laptop=no
110wifi=no
111if [ -x /usr/sbin/laptop-detect ] && /usr/sbin/laptop-detect 2>/dev/null; then
112    laptop=yes
113fi
114
115if [ -x /usr/bin/nmcli ] && /usr/bin/nmcli dev status 2>/dev/null | awk '{print $2}' | grep -q 802-11-wireless; then
116    wifi=yes
117fi
118
119echo "Welcome to the Debathena installer."
120echo ""
121echo "Please choose the category which best suits your needs.  Each category"
122echo "in this list includes the functionality of the previous ones.  See the"
123echo "documentation at http://debathena.mit.edu for more information."
124echo ""
125echo "  standard:        Athena client software and customizations"
126echo "                   Recommended for laptops and single-user computers."
127echo "  login:           Allow Athena accounts to log into your machine"
128echo "                   Recommended for private remote-access servers."
129echo "  login-graphical: Athena graphical login customizations"
130echo "                   Recommended for private multi-user desktops."
131echo "  workstation:     Graphical workstation with automatic updates"
132echo "                   Recommended for auto-managed cluster-like systems."
133echo ""
134
135if [ "$laptop" = "yes" ] || [ "$wifi" = "yes" ]; then
136    cat <<EOF
137This machine appears to be a laptop or has at least one wireless
138network device.  You probably want to choose "standard" unless this
139device will have an uninterrupted network connection.
140EOF
141fi
142
143category=""
144if [ cluster = "$pxetype" ] ; then
145  category=cluster ;
146  echo "PXE cluster install detected, so installing \"cluster\"."
147fi
148while [ standard != "$category" -a login != "$category" -a \
149        login-graphical != "$category" -a workstation != "$category" -a \
150        cluster != "$category" ]; do
151  output -n "Please choose a category or press control-C to abort: "
152  read category
153done
154
155if [ cluster = "$category" ]; then
156  # We still want these set for cluster installs, which should be truly
157  # noninteractive
158  export DEBCONF_NONINTERACTIVE_SEEN=true
159  export DEBIAN_FRONTEND=noninteractive
160fi
161
162mainpackage=debathena-$category
163
164csoft=no
165tsoft=no
166resolvconfhack=no
167echo "The extra-software package installs a standard set of software"
168echo "determined to be of interest to MIT users, such as LaTeX.  It is pretty"
169echo "big (several gigabytes, possibly more)."
170echo ""
171echo "Note: This package may include software with additional license terms."
172echo "      By installing it, you are agreeing to the terms of these licenses."
173echo "      For more information, please see http://debathena.mit.edu/licensing"
174echo ""
175if [ cluster = $category -o workstation = $category ] ; then
176  # See Trac #648 and LP:471975
177  resolvconfhack=yes
178  echo "The extra-software package is required for '$category' and will be installed."
179  csoft=yes
180  # Not setting tsoft=yes here; -cluster will pull it in anyway.
181else
182  ask "Do you want the extra-software package [y/N]? " n
183  if [ y = "$answer" ]; then
184    csoft=yes
185  fi
186fi
187if [ yes = "$csoft" ]; then
188    # Preseed an answer to the java license query, which license was already accepted
189    # at install time:
190    echo "sun-java6-bin shared/accepted-sun-dlj-v1-1 boolean true" |debconf-set-selections
191fi
192
193if [ "$(cat /sys/class/dmi/id/product_name)" = "OptiPlex 790" ] && \
194    dpkg --compare-versions "$(uname -r)" lt 3.2~; then
195    noacpi=y
196    if [ "$category" != "cluster" ]; then
197        echo
198        echo "The Dell 790 sometimes has problems rebooting.  The best way to"
199        echo "work around this is to pass 'reboot=pci' at boot time."
200        echo "This change will be made in your GRUB (bootloader) configuration."
201        ask "Is it ok to do this now? [Y/n] " y
202        if [ y != "$answer" ]; then
203            noacpi=n
204        fi
205    fi
206    if [ "$noacpi" = "y" ] && ! grep -q "Added by install-debathena.sh to address reboot issues on the Dell 790" /etc/default/grub; then
207        cat >> /etc/default/grub << 'EOF'
208
209# Added by install-debathena.sh to address reboot issues on the Dell 790
210GRUB_CMDLINE_LINUX="reboot=pci $GRUB_CMDLINE_LINUX"
211EOF
212        update-grub
213    fi
214fi
215
216echo "A summary of your choices:"
217echo "  Category: $category"
218echo "  Extra-software package: $csoft"
219echo "  Third-party software package: $tsoft"
220echo ""
221if [ "$pxetype" = "cluster" ] ; then
222  if wget -q http://athena10.mit.edu/installer/installing.txt; then
223     cat installing.txt > /dev/tty6
224     date > /dev/tty6
225     chvt 6
226     rm installing.txt
227  fi
228  # Divert the default background and install our own so that failed machines
229  # are more conspicuous
230  echo "Diverting default background..."
231  bgimage=/usr/share/backgrounds/warty-final-ubuntu.png
232  divertedbg=no
233  if dpkg-divert --divert ${bgimage}.debathena --rename $bgimage; then
234      divertedbg=yes
235      if ! wget -N -O $bgimage http://debathena.mit.edu/error-background.png; then
236          echo "Hrm, that didn't work.  Oh well..."
237          dpkg-divert --rename --remove $bgimage
238          divertedbg=no
239      fi
240  fi
241
242  # Setup for package installs in a chrooted immediately-postinstall environment.
243  echo "Setting locale."
244  export LANG
245  . /etc/default/locale
246  echo "LANG set to $LANG."
247  echo "Mounting /proc."
248  mount /proc 2> /dev/null || :
249  # Clear toxic environment settings inherited from the installer.
250  unset DEBCONF_REDIR
251  unset DEBIAN_HAS_FRONTEND
252  if [ cluster = "$pxetype" ] ; then
253    # Network, LVM, and display config that's specific to PXE cluster installs.
254    # If someone is installing -cluster on an already-installed machine, it's
255    # assumed that this config has already happened and shouldn't be stomped on.
256
257    # Configure network based on the preseed file settings, if present.
258    if test -f /root/debathena.preseed && ! grep -q netcfg/get_ipaddress /proc/cmdline; then
259      # Switch to canonical hostname.
260      ohostname=`cat /etc/hostname`
261      # Hack to avoid installing debconf-get for just this.
262      ipaddr=`grep netcfg/get_ipaddress /root/debathena.preseed|sed -e 's/.* //'`
263      netmask=`grep netcfg/get_netmask /root/debathena.preseed|sed -e 's/.* //'`
264      gateway=`grep netcfg/get_gateway /root/debathena.preseed|sed -e 's/.* //'`
265
266      hostname=`host $ipaddr | \
267          sed 's#^.*domain name pointer \(.*\)$#\1#' | sed 's;\.*$;;' | \
268          tr '[A-Z]' '[a-z]'`
269      if echo $hostname|grep -q "not found" ; then
270        hostname=""
271        printf "\a"; sleep 1 ; printf "\a"; sleep 1 ;printf "\a"
272        echo "The IP address you selected, $ipaddr, does not have an associated"
273        echo "hostname.  Please confirm that you're using the correct address."
274        while [ -z "$hostname" ] ; do
275          echo -n "Enter fully qualified hostname [no default]: "
276          read hostname
277        done
278      fi
279      echo ${hostname%%.*} > /etc/hostname
280      sed -e 's/\(127\.0\.1\.1[         ]*\).*/\1'"$hostname ${hostname%%.*}/" < /etc/hosts > /etc/hosts.new
281      mv -f /etc/hosts.new /etc/hosts
282      if grep -q dhcp /etc/network/interfaces ; then
283        sed -e s/dhcp/static/ < /etc/network/interfaces > /etc/network/interfaces.new
284        echo "  address $ipaddr" >> /etc/network/interfaces.new
285        echo "  netmask $netmask" >> /etc/network/interfaces.new
286        echo "  gateway $gateway" >> /etc/network/interfaces.new
287        echo "  dns-nameservers 18.72.0.3 18.70.0.160 18.71.0.151" >> /etc/network/interfaces.new
288        mv -f /etc/network/interfaces.new /etc/network/interfaces
289      fi
290      hostname ${hostname%%.*}
291    fi
292
293  fi
294else
295  output "Press return to begin or control-C to abort"
296  read dummy
297fi
298
299# Set the "seen" flag for all debconf questions that we configure
300# cluster is still non-interactive, see above.
301# Except you can't set the "seen" flag for something that isn't installed
302# so also set some sane defaults
303cat <<EOF | debconf-set-selections
304# Set sane defaults
305openafs-client  openafs-client/thiscell string grand.central.org
306openafs-client  openafs-client/cachesize string 150000
307# A null value is fine as of krb5 1.6.dfsg.3-1
308krb5-config     krb5-config/default_realm string
309# No value means use Hesiod
310zephyr-clients  zephyr-clients/servers string
311# Then mark them as seen
312openafs-client  openafs-client/thiscell seen true
313openafs-client  openafs-client/cachesize seen true
314krb5-config     krb5-config/default_realm seen true
315zephyr-clients  zephyr-clients/servers seen true
316# These are also questions asked by default, but
317# the user should probably see them anyway.
318#gdm     shared/default-x-display-manager seen true
319#cyrus-common    cyrus-common/removespool seen true
320#hddtemp hddtemp/daemon seen true
321EOF
322
323apt-get update
324
325output "Verifying machine is up to date..."
326pattern='^0 upgraded, 0 newly installed, 0 to remove'
327if ! apt-get --simulate --assume-yes dist-upgrade | grep -q "$pattern"; then
328    if [ -n "$pxetype" ] ; then
329        output "Forcing an upgrade"
330        apt-get --assume-yes dist-upgrade
331    else
332        error "Your system is not up to date.  Proceeding with an install at"
333        error "this time could render your system unusable."
334        error "Please run 'apt-get dist-upgrade' as root or use the GUI update"
335        error "manager to ensure your system is up to date before continuing."
336        error "NOTE: You do NOT need to upgrade to a newer release of Ubuntu",
337        error "you merely need to ensure you have the latest software updates"
338        error "for the current version."
339        exit 1
340    fi
341fi
342
343if ! hash aptitude >/dev/null 2>&1; then
344  output "Installing Debathena installer dependency: aptitude"
345  apt-get -y install aptitude
346fi
347
348output "Installing Debathena installer dependencies: wget and dnsutils"
349apt-get -y install wget dnsutils
350if [ yes = "$resolvconfhack" ]; then
351  output "Installing resolvconf ahead of time"
352  apt-get -y install resolvconf
353fi
354
355# Only add our openafs component if DKMS isn't available
356openafs_component=""
357if aptitude show openafs-modules-dkms > /dev/null; then
358  modules="openafs-modules-dkms"
359else
360  openafs_component=" openafs"
361fi
362
363# Select the correct headers package
364kernel_hdr_meta_pkgs=
365if [ "$ubuntu" = "yes" ]; then
366    # Ubuntu kernel metapackages have a source of 'linux-meta'
367    # Find all of them and replace "-image-" with "-headers-".
368    kernel_hdr_meta_pkgs=$(dpkg-query -W -f '${Source}\t${Package}\n' 'linux-image-*' | awk '$1=="linux-meta" { sub(/-image-/, "-headers-", $2); print $2 }')
369else
370    # Debian.  "Yay".  Old squeeze has linux-latest-2.6 as the
371    # metapackage.  squeeze-backpors and newer have linux-latest as
372    # the metpackage.  For bonus points, wheezy can have two packages
373    # installed with linux-latest as the metapackage, because one of
374    # those is itself a metapckage.
375    kernel_hdr_meta_pkgs=$(dpkg-query -W -f '${Source}::${Package}\n' 'linux-image-*' | awk -F:: '$1~/^linux-latest/ { sub(/-image-/, "-headers-", $2); print $2 }')
376fi
377pkgs_to_install=
378for p in $kernel_hdr_meta_pkgs; do
379    # Only install real packages
380    if apt-cache show $p | grep -q '^Source: '; then
381        pkgs_to_install=" $p"
382    fi
383done
384if [ -z "$pkgs_to_install" ]; then
385    output "We cannot find a kernel header metapackage for your kernel."
386    output "You will need one in order for DKMS to build the openafs"
387    output "kernel module.  You should probably stop here and figure out"
388    output "what kernel metapackage you're running, and install the"
389    output "corresponding kernel headers package."
390    ask "Do you want to continue anyway? [y/N] " n
391    if [ y != "$answer" ]; then
392        exit 0
393    fi
394else
395    output "Installing header packages: $pkgs_to_install"
396    apt-get -y install $pkgs_to_install
397fi
398
399output "Adding the Debathena repository to the apt sources"
400output "(This may cause the update manager to claim new upgrades are available."
401output "Ignore them until this script is complete.)"
402sourceslist=/etc/apt/sources.list.d/debathena.list
403clustersourceslist=/etc/apt/sources.list.d/debathena.clusterinfo.list
404if [ -z "$hostname" ] ; then hostname=`hostname` ; fi
405
406if [ ! -e "$sourceslist" ] || ! grep -v ^# "$sourceslist" | grep -q debathena; then
407  if [ -e "$sourceslist" ]; then
408    echo "" >> $sourceslist
409  fi
410  echo "deb http://debathena.mit.edu/apt $distro debathena debathena-config debathena-system$openafs_component" >> $sourceslist
411  echo "deb-src http://debathena.mit.edu/apt $distro debathena debathena-config debathena-system$openafs_component" >> $sourceslist
412fi
413
414# Note that hesiod may contain multiple apt_release tokens.  We want to
415# include known repositories but make no assumptions about wanting
416# others.  (For instances, "development" does @i{not} automatically
417# infer "proposed".)
418hescluster=$(dig +short +bufsize=2048 ${hostname}.cluster.ns.athena.mit.edu TXT) || hescluster=""
419
420aptexplained=false
421for hc in proposed development bleeding; do
422  if echo "$hescluster" | grep -Fxq "\"apt_release $hc\""; then
423    echo "Adding $distro-$hc apt repository."
424    if [ "${aptexplained}" = false ] ; then
425      echo "" >> $clustersourceslist
426      echo "# This file is automatically updated by debathena-auto-update" >> $clustersourceslist
427      echo "# based on your Hesiod cluster information. If you want to" >> $clustersourceslist
428      echo "# make changes, do so in another file." >> $clustersourceslist
429      aptexplained=true
430    fi
431    echo "" >> $clustersourceslist
432    echo "deb http://debathena.mit.edu/apt $distro-${hc} debathena debathena-config debathena-system$openafs_component" >> $clustersourceslist
433    echo "deb-src http://debathena.mit.edu/apt $distro-${hc} debathena debathena-config debathena-system$openafs_component" >> $clustersourceslist
434  fi
435done
436
437if [ "$ubuntu" = "yes" ]; then
438  output "Making sure the universe repository is enabled"
439  sed -i 's,^# \(deb\(\-src\)* http://archive.ubuntu.com/ubuntu [[:alnum:]]* universe\)$,\1,' /etc/apt/sources.list
440fi
441
442output "Downloading the Debathena archive signing key"
443if ! wget -N http://debathena.mit.edu/apt/debathena-archive-keyring.asc ; then
444  error "Download failed; terminating."
445  exit 1
446fi
447echo "fa787714d1ea439c28458aab64962f755e2bdee7a3520919a72b641458757fa3586fd269cc1dae8d99047e00b3df88db0826f0c99a1f5a8771618b3c0be8e3bd  ./debathena-archive-keyring.asc" | \
448  sha512sum -c
449apt-key add debathena-archive-keyring.asc
450rm ./debathena-archive-keyring.asc
451
452$aptitude update
453
454if [ -z "$modules" ]; then
455  modules_want=$(dpkg-query -W -f '${Source}\t${Package}\n' 'linux-image-*' | \
456   sed -nre 's/^linux-(meta|latest[^\t]*)\tlinux-image-(.*)$/openafs-modules-\2/p')
457  modules=
458  for m in $modules_want; do
459    aptitude show $m > /dev/null && modules="$modules $m"
460  done
461fi
462
463if [ -z "$modules" ]; then
464  error "An OpenAFS modules metapackage for your kernel is not available."
465  error "Please use the manual installation instructions at"
466  error "http://debathena.mit.edu/install"
467  error "You will need to compile your own AFS modules as described at:"
468  error "http://debathena.mit.edu/troubleshooting#openafs-custom"
469  exit 1
470fi
471
472output "Installing OpenAFS kernel metapackage"
473apt-get -y install $modules
474
475if [ "cluster" = "$category" ] || [ "workstation" = "$category" ] ; then
476    output "Installing debathena-license-config"
477    apt-get -y install debathena-license-config
478fi
479
480# Use the noninteractive frontend to install the main package.  This
481# is so that AFS and Zephyr don't ask questions of the user which
482# debathena packages will later stomp on anyway.
483output "Installing main Debathena metapackage $mainpackage"
484
485$aptitude -y install "$mainpackage"
486
487# Use the default front end and allow questions to be asked; otherwise
488# Java will fail to install since it has to present its license.
489if [ yes = "$csoft" ]; then
490  output "Installing debathena-extra-software"
491  DEBIAN_PRIORITY=critical $aptitude -y install debathena-extra-software
492fi
493if [ yes = "$tsoft" ]; then
494  output "Installing debathena-thirdparty"
495  DEBIAN_PRIORITY=critical $aptitude -y install debathena-thirdparty
496fi
497
498# Post-install cleanup for cluster systems.
499if [ "$divertedbg" = "yes" ]; then
500    rm -f $bgimage
501    if ! dpkg-divert --rename --remove $bgimage; then
502        echo "Failed to remove diversion of background.  You probably don't care."
503    fi
504fi
505
506if [ cluster = "$category" ] ; then
507  # Force an /etc/adjtime entry so there's no confusion about whether the
508  # hardware clock is UTC or local.
509  echo "Setting hardware clock to UTC."
510  hwclock --systohc --utc
511fi
Note: See TracBrowser for help on using the repository browser.